#!/usr/bin/python
# -*- coding: utf-8 -*-

from Screens.Screen import Screen
from Components.Sources.StaticText import StaticText
from Components.Label import Label
from Components.ActionMap import ActionMap
from enigma import getDesktop
from Components.config import config
from Components.Sources.EventInfo import EventInfo

sz_w = getDesktop(0).size().width()

class myWidgetScreen(Screen):
	if sz_w == 1920:	#1920 x 1080 FHD
		skin = """
		<screen name="TestPluginScreen" position="950,530" size="220,40" flags="wfNoBorder" backgroundColor="#ff000000">
			<widget source="session.Event_Now" render="Label" position="0,0" zPosition="7" size="220,40" backgroundColor="#00101214" foregroundColor="#00e5b243" font="Regular;32" valign="center" halign="right" transparent="1">
				<convert type="EventTime">Remaining</convert>
				<convert type="RemainingToText"/>
			</widget>
		</screen>"""
	else:
		# HD 1280720
		skin = """
		<screen name="TestPluginScreen" position="670,430" size="120,40" flags="wfNoBorder" backgroundColor="#ff000000">
			<widget source="session.Event_Now" render="Label" position="0,0" zPosition="7" size="120,40" backgroundColor="#00101214" foregroundColor="#00e5b243" font="Regular;26" valign="center" halign="right" transparent="1">
				<convert type="EventTime">Remaining</convert>
				<convert type="RemainingToText"/>
			</widget>
		</screen>"""
	def __init__(self, session):
		Screen.__init__(self, session)


class TestPluginScreen(Screen):
	if sz_w == 1920:	#1920 x 1080 FHD
		skin = """
		<screen name="TestPluginScreen" position="center,200" size="1220,680">
			<ePixmap pixmap="skin_default/buttons/red.png" position="0,0" size="300,70" scale="stretch" alphatest="on" />
			<ePixmap pixmap="skin_default/buttons/green.png" position="300,0" size="300,70" scale="stretch" alphatest="on" />
			<ePixmap pixmap="skin_default/buttons/yellow.png" position="600,0" size="300,70" scale="stretch" alphatest="on" />
			<ePixmap pixmap="skin_default/buttons/blue.png" position="900,0" size="300,70" scale="stretch" alphatest="on" />
			<widget source="key_red" render="Label" position="0,0" zPosition="1" size="300,70" font="Regular;32" halign="center" valign="center" backgroundColor="#9f1313" transparent="1" />
			<widget source="key_green" render="Label" position="300,0" zPosition="1" size="300,70" font="Regular;32" halign="center" valign="center" backgroundColor="#1f771f" transparent="1" />
			<widget source="key_yellow" render="Label" position="600,0" zPosition="1" size="300,70" font="Regular;32" halign="center" valign="center" backgroundColor="#a08500" transparent="1" />
			<widget source="key_blue" render="Label" position="900,0" zPosition="1" size="300,70" font="Regular;32" halign="center" valign="center" backgroundColor="#18188b" transparent="1" />
			<widget source="myEvent_Now" render="Label" position="280,332" zPosition="7" size="220,40" backgroundColor="#00101214" foregroundColor="#00e5b243" font="Regular;32" valign="center" halign="right" transparent="1">
				<convert type="EventTime">Remaining</convert>
				<convert type="RemainingToText"/>
			</widget>
			<widget source="session.Event_Now" render="Label" position="880,332" zPosition="7" size="220,40" backgroundColor="#00101214" foregroundColor="#00e5b243" font="Regular;32" valign="center" halign="right" transparent="1" text="myWidget">
				<convert type="EventTime">Remaining</convert>
				<convert type="RemainingToText"/>
			</widget>
		</screen>"""
	else:
		# HD 1280720
		skin = """
		<screen name="TestPluginScreen" position="center,100" size="800,500">
			<ePixmap pixmap="skin_default/buttons/red.png" position="0,0" size="200,40" scale="stretch" alphatest="on" />
			<ePixmap pixmap="skin_default/buttons/green.png" position="200,0" size="200,40" scale="stretch" alphatest="on" />
			<ePixmap pixmap="skin_default/buttons/yellow.png" position="400,0" size="200,40" scale="stretch" alphatest="on" />
			<ePixmap pixmap="skin_default/buttons/blue.png" position="600,0" size="200,40" scale="stretch" alphatest="on" />
			<widget source="key_red" render="Label" position="0,0" zPosition="1" size="200,40" font="Regular;22" halign="center" valign="center" backgroundColor="#9f1313" transparent="1" />
			<widget source="key_green" render="Label" position="200,0" zPosition="1" size="200,40" font="Regular;22" halign="center" valign="center" backgroundColor="#1f771f" transparent="1" />
			<widget source="key_yellow" render="Label" position="400,0" zPosition="1" size="200,40" font="Regular;22" halign="center" valign="center" backgroundColor="#a08500" transparent="1" />
			<widget source="key_blue" render="Label" position="600,0" zPosition="1" size="200,40" font="Regular;22" halign="center" valign="center" backgroundColor="#18188b" transparent="1" />
			<widget source="myEvent_Now" render="Label" position="235,332" zPosition="7" size="120,40" backgroundColor="#00101214" foregroundColor="#00e5b243" font="Regular;26" valign="center" halign="right" transparent="1">
				<convert type="EventTime">Remaining</convert>
				<convert type="RemainingToText"/>
			</widget>
			<widget source="session.Event_Now" render="Label" position="635,332" zPosition="7" size="120,40" backgroundColor="#00101214" foregroundColor="#00e5b243" font="Regular;26" valign="center" halign="right" transparent="1" text="myWidget">
				<convert type="EventTime">Remaining</convert>
				<convert type="RemainingToText"/>
			</widget>
		</screen>"""
		
	def __init__(self, session, skinValue=0):
		Screen.__init__(self, session)
		
		self.setTitle("TEST TestPlugin WidgetShowHide")
		
		#instantiate and delete myWidgetScreen
		self.onLayoutFinish.append(self.onLayoutFinished)
		self.onClose.append(self.deleteMyWidgetScreen)
		
		# Initialize widgets
		self["key_red"] = StaticText(_("Cancel"))
		self["key_green"] = StaticText(_("Pos1"))
		self["key_yellow"] = StaticText("Pos2")
		self["key_blue"] = StaticText("Pos3")
		
		self["myEvent_Now"] = EventInfo(self.session.nav, EventInfo.NOW)
		
		# Define Actions
		self["actions"] = ActionMap(["SetupActions", "ColorActions","MediaPlayerActions"],
			{
				"cancel": 	self.close,
				"green": 	self.green_key,
				"yellow": 	self.pos2,
				"blue":		self.pos3,
				"ok":		self.green_key,
			},-2)
		
		try:
			pass
		
		except:
			import traceback, sys
			traceback.print_exc()

	def onLayoutFinished(self):
		self.myWidgetScreen = self.session.instantiateDialog(myWidgetScreen, zPosition=100)
		self.myWidgetScreen.show()
		
	def deleteMyWidgetScreen(self):
		self.session.deleteDialog(self.myWidgetScreen)

	def green_key(self):
		
		try:
			from pprint import pprint
			
			for element in self["myEvent_Now"].downstream_elements:
				pprint(vars(element))
				print("===", self["myEvent_Now"].master)
				for element1 in element.downstream_elements:
					#pprint(vars(element1))
					if ".Renderer." in str(element1.master.__class__):
						if element1.master.getVisible():
							element1.master.hide()
						else:
							element1.master.show()
		
		except:
			import traceback, sys
			traceback.print_exc()

	def pos2(self):
		try:
			print "===", self.myWidgetScreen.instance.isVisible()
			if self.myWidgetScreen.instance.isVisible():
				self.myWidgetScreen.hide()
			else:
				self.myWidgetScreen.instance.setZPosition(100)
				self.myWidgetScreen.show()

		except:
			import traceback
			traceback.print_exc()

	def pos3(self):
		try:
			from pprint import pprint
			
			for element in self.session.screen["Event_Now"].downstream_elements:
				#pprint(vars(element))
				if ".RemainingToText." in str(element.master.__class__):
					print("=== master ", element.master)
					for element1 in element.downstream_elements:
						pprint(vars(element1))
						
						for element2 in element1.downstream_elements:
							pprint(vars(element2))
							if "eLabel" in str(element2.instance.__class__):
								#search for your own widget with is marked with text="myWidget"
								if self.checkAttributes(element2):
									if element2.instance.isVisible():
										element2.instance.hide()
									else:
										element2.instance.show()
			
		except:
			import traceback
			traceback.print_exc()
	
	
	def checkAttributes(self, element):
		check = False
		if element.skinAttributes is not None:
			for (attrib, value) in element.skinAttributes:
				if attrib == "text" and value == "myWidget":
					check=True
		return check


